;ͻ
;                         Summit BETA 4۲                             
;                           Summit Header File                              
;                                Summit.h                                   
;                           September 19, 1998                              
;͹
;                            by Richard Lewis                               
;                       RichardLewis@CedarCity.net                          
;                                                                           
;                           Name by Greg Sharp                              
;                            BSharp81@aol.com                               
;ͼ
;Ŀ
; Shell Version data in BCD (Binary Coded Decimal) format                   
;
SUMMIT_B4       =$04
RIGEL_VER       =$10
USGARD_15L_VER  =$24
USGARD_15F_VER  =$25
ZSHELL4_VER     =$40
PHATOS_VER      =$50

;Ŀ
; Graph Screen Macros (Shouldn't affect ASM at all)                         
;
#DEFINE GUSE_GRAPH		res 0,(IY+$03)
#DEFINE GREDRAW_GRAPH		set 0,(IY+$03)
#DEFINE GLABELS_ON		set 6,(IY+$04)
#DEFINE GLABELS_OFF		res 6,(IY+$04)
#DEFINE GAXES_OFF		set 5,(IY+$04)
#DEFINE GAXES_ON		res 5,(IY+$04)
#DEFINE GCURSOR_OFF		set 4,(IY+$04)
#DEFINE GCURSOR_ON		res 4,(IY+$04)
#DEFINE GPOLAR_GC		set 3,(IY+$04)
#DEFINE GRECT_GC		res 3,(IY+$04)
#DEFINE GGRID_ON		set 2,(IY+$04)
#DEFINE GGRID_OFF		res 2,(IY+$04)
#DEFINE GSIMUL_G		set 1,(IY+$04)
#DEFINE GSEQ_G			res 1,(IY+$04)
#DEFINE GDRAW_DOT		set 0,(IY+$04)
#DEFINE GDRAW_LINE		res 0,(IY+$04)

;Ŀ
; Cursor Macros                                                             
;
#DEFINE CURSOR_ON		set 2,(IY+$0C)
#DEFINE CURSOR_OFF		res 2,(IY+$0C)
#DEFINE ALPHA_ON		set 4,(IY+$12)
#DEFINE ALPHA_OFF		res 4,(IY+$12)
#DEFINE USE_ALPHA		res 5,(IY+$12)
#DEFINE USE_alpha		set 5,(IY+$12)
#DEFINE LOCK_ALPHA		set 6,(IY+$12)
#DEFINE ULOCK_ALPHA		res 6,(IY+$12)
#DEFINE INSERT_ON		set 6,(IY+$05)
#DEFINE INSERT_OFF		set 6,(IY+$05)

;Ŀ
; Printing option macros                                                    
;
#DEFINE	PB_ON_W			res 3,(IY+$05)
#DEFINE PW_ON_B			set 3,(IY+$05)
#DEFINE PM7_ROWS		set 1,(IY+$05)
#DEFINE PM6_ROWS		res 1,(IY+$05)
#DEFINE PSCROLL			set 2,(IY+$0D)
#DEFINE PNO_SCROLL		res 2,(IY+$0D)
#DEFINE PAFFECT_TEXT		set 1,(IY+$0D)
#DEFINE PNO_AFFECT_TEXT		res 1,(IY+$0D)

;Ŀ
; Useful Misc. Command Macros                                               
;
#DEFINE APD_ON                  set 3,(IY+8) ; Turns APD on!  Wow!
#DEFINE APD_OFF                 res 3,(IY+8) ; Turns APD off!  Wow!
#DEFINE BBUSY_ON                set 0,(IY+$12)  ;turns busy indicator on
#DEFINE BBUSY_OFF               res 0,(IY+$12)  ;turns busy indicator off
#DEFINE GET_VAR                 LD_OP1_HL \ SEARCH_VAT

;Ŀ
; rst Commands                                                              
;
#DEFINE LD_OP2_OP1              rst 08H ; 11 bytes copied from OP1 to OP2
#DEFINE SEARCH_VAT              rst 10H ; Searches VAT for Variable
#DEFINE LD_OP1_HL               rst 20H ; OP1=(HL)
#DEFINE MUL_OP1_OP2             rst 28H ; OP1=OP1*OP2 (FP)
#DEFINE ADD_OP1_OP2             rst 30H ; OP1=OP1+OP2 (FP)

;Ŀ
; Straight ROM Calls                                                        
;
D_COLON		=$0094	; displays a ":" at normal text cursor
ETR_CHARPUT     =$0096  ; same as TR_CHARPUT ROM_CALL, but faster and in the
			; same place in ALL ROM versions
UPDATE_BUSY	=$00AC	; update busy counter & redraw bitmap
READ_KEYPAD     =$01A2  ; read keypad port directly
ALPHA1          =$01CB  ; call ALPHA3 if alpha mode locked
ALPHA2          =$01D6
ALPHA3          =$01DA
APD_RESET       =$0115  ; resets $8009 to $A1
READ_KEY        =$0168  ; get keystroke into %A, use ports directly
ERR_WRITE	=$03D9	; write A% in to Error Buffer
GET_CHECKSUM    =$0CAD  ; check sum memory between 8BF7 and FA6F

;Ŀ
; Straight ROM Jumps                                                        
;
HOME_SCREEN	=$0462	; jump to home screen, and display contents of
			; TEXT_MEM as ascii equivalents
D_ERROR         =$0A87  ; display Error number A%

;Ŀ
; Summit specific data areas                                                
;
ROM_TAB         =$8C41  ; ROM Table used for ROM calls
AUTORUN_STR     =$8C9B  ; Length indexed string: 5,"AUTOR"
ORIGINAL_SP     =$8CB3  ; used by quick exits
INT_TABLE       =$8D00  ; DO NOT USE FOR DATA, unless you know exactly what
                        ; you're doing
C_PROG          =$8E64  ;
VC_NAME         =$8E78  ; returned name for VAT_CHECK
TSR_NAME        =$8E82  ; name of current TSR program
INT_LOCATION    =$8E8C  ; location of current interrupt routine

;Ŀ
; ZShell 4.0 compatible ROM Macros (Fast Method)                            
; NOTE: These do exactly the same thing as the ROM_CALLs, but they're       
;       faster (Approximately 300 clock cycles faster) and smaller          
; To convert a ZShell 4.0 program's rom calls, just add a 'Q' in front of   
;       them.  :)  The Q is for quick.  :)                                  
;
#DEFINE QROM_CALL(index)        call (index*3)+ROM_TAB
#DEFINE ZTX_CHARPUT     call ROM_TAB
#DEFINE ZD_LT_STR       call ROM_TAB+3
#DEFINE ZM_CHARPUT      call ROM_TAB+6
#DEFINE ZD_ZM_STR       call ROM_TAB+9
#DEFINE ZD_LM_STR       call ROM_TAB+12
#DEFINE ZGET_T_CUR      call ROM_TAB+15
#DEFINE ZSCROLL_UP      call ROM_TAB+18
#DEFINE ZTR_CHARPUT     call ROM_TAB+21
#DEFINE ZCLEARLCD       call ROM_TAB+24
#DEFINE ZD_HL_DECI      call ROM_TAB+27
#DEFINE ZCLEARTEXT      call ROM_TAB+30
#DEFINE ZD_ZT_STR       call ROM_TAB+33
#DEFINE ZBUSY_OFF       call ROM_TAB+36
#DEFINE ZBUSY_ON        call ROM_TAB+39
#DEFINE ZFIND_PIXEL     call ROM_TAB+42

;Ŀ
; ZShell ROM jumps                                                          
;
#DEFINE JTX_CHARPUT     jp ROM_TAB
#DEFINE JD_LT_STR       jp ROM_TAB+3
#DEFINE JM_CHARPUT      jp ROM_TAB+6
#DEFINE JD_ZM_STR       jp ROM_TAB+9
#DEFINE JD_LM_STR       jp ROM_TAB+12
#DEFINE JGET_T_CUR      jp ROM_TAB+15
#DEFINE JSCROLL_UP      jp ROM_TAB+18
#DEFINE JTR_CHARPUT     jp ROM_TAB+21
#DEFINE JCLEARLCD       jp ROM_TAB+24
#DEFINE JD_HL_DECI      jp ROM_TAB+27
#DEFINE JCLEARTEXT      jp ROM_TAB+30
#DEFINE JD_ZT_STR       jp ROM_TAB+33
#DEFINE JBUSY_OFF       jp ROM_TAB+36
#DEFINE JBUSY_ON        jp ROM_TAB+39
#DEFINE JFIND_PIXEL     jp ROM_TAB+42

;Ŀ
; Summit specific ROM calls                                                 
;
#DEFINE ZB_BYTES        call ROM_TAB+45
#DEFINE MUL_HL          call ROM_TAB+48
#DEFINE ALLOCATE        call ROM_TAB+51
#DEFINE DELETE_VAR      call ROM_TAB+54
#DEFINE REMOVE_DE       call ROM_TAB+57
#DEFINE VPOP_A          call ROM_TAB+60
#DEFINE VPUSH_A         call ROM_TAB+63
#DEFINE GRAPH2LCD       call ROM_TAB+66
#DEFINE D_MENU          call ROM_TAB+69
#DEFINE SAVE_TEXT       call ROM_TAB+72
#DEFINE SAVE_TEXM       call ROM_TAB+75
#DEFINE CLR_WINDOW      call ROM_TAB+78
#DEFINE CLR_LINE        call ROM_TAB+81
#DEFINE C2TOP           call ROM_TAB+84
#DEFINE KEY_HANDLER     call ROM_TAB+87

;Ŀ
; Summit specific ROM jumps                                                 
;

#DEFINE JZB_BYTES        jp ROM_TAB+45
#DEFINE JMUL_HL          jp ROM_TAB+48
#DEFINE JALLOCATE        jp ROM_TAB+51
#DEFINE JDELETE_VAR      jp ROM_TAB+54
#DEFINE JREMOVE_DE       jp ROM_TAB+57
#DEFINE JVPOP_A          jp ROM_TAB+60
#DEFINE JVPUSH_A         jp ROM_TAB+63
#DEFINE JGRAPH2LCD       jp ROM_TAB+66
#DEFINE JD_MENU          jp ROM_TAB+69
#DEFINE JSAVE_TEXT       jp ROM_TAB+72
#DEFINE JSAVE_TEXM       jp ROM_TAB+75
#DEFINE JCLR_WINDOW      jp ROM_TAB+78
#DEFINE JCLR_LINE        jp ROM_TAB+81
#DEFINE JC2TOP           jp ROM_TAB+84
#DEFINE JKEY_HANDLER     jp ROM_TAB+87

;Ŀ
; Internal Summit routines (Straight Call Functions)                        
;
#DEFINE EXE             call $8CA1      ; input: (OP1)=Variable data, Output:
                                        ; Run the program after checking
                                        ; header (ZS & Summit)
#DEFINE SET_DEF         call $8CA4      ; set defaults for program execution
#DEFINE EXE_HL          call $8CA7      ; execute program, using HL to make
                                        ; (PROGRAM_ADDR)
                                        ; THIS DOES ZERO ERROR CHECKING!!!!!!
#DEFINE FILL8           call $8CAA      ; fill B bytes with A at (HL)
#DEFINE G_PAUSE         call $8CB5
#DEFINE G_WAIT          call $8CB8
#DEFINE FILL16          call $8CBB
#DEFINE CLEAR16         call $8CBE
#DEFINE CLEAR8          call $8CC1
#DEFINE INT_INS         call $8CC4
#DEFINE INT_REMOVE      call $8CC7
#DEFINE DM_HL_DECI      call $8CCA
#DEFINE SHUT_DOWN       call $8CCD
#DEFINE VAT_CHECK       call $8CD0
#DEFINE NEW_VAR         call $8CD3
#DEFINE DEL_VAR         call $8CD6      ;Relocated programs only, unless you
                                        ;know exactly what you're doing.
#DEFINE RESIZE_VAR      call $8CD9
#DEFINE RELO_VAR        call $8CDC
#DEFINE TSR_INSTALL     call $8CDF
#DEFINE TSR_REMOVE      call $8CE2
#DEFINE CLEAN_INT       call $8CE5

;Ŀ
; Internal Summit routines (Straight Jump Functions)                        
;
#DEFINE EXIT_BREAK      jp $8CAD
#DEFINE EXIT_SHELL      jp $8CB0

;Ŀ
; TI-85 Data Areas                                                          
;
APD_COUNTER	=$8008	; 2 byte counter used for APD
BLINK_COUNTER	=$800A	; 2 byte counter used for blinking cursors
DELCHAR_LEN	=$800F	; length of DELCHAR buffer (max 100)
DELCHAR_BUF	=$8010	; 100 byte buffer for copy/paste in program editor
TOPR_BITMAP     =$8078  ; bitmap of top right corner of display (8 bytes)
OP1		=$8082	; OP1 register for variable manipulation (11 bytes)
OP2		=$808D	; OP2 register for variable manipulation (11 bytes)
OP3		=$8098	; OP3 register for variable manipulation (11 bytes)
OP4		=$80A3	; OP4 register for variable manipulation (11 bytes)
                        ; Also used to store a ZT string of last thing
                        ; displayed on Home Screen
OP5		=$80AE	; OP5 register for variable manipulation (11 bytes)
OP6		=$80B9	; OP6 register for variable manipulation (11 bytes)
ANS_POINT       =$80D0  ; pointer to Ans
FINAL_VAT       =$80D6  ; pointer to last VAT entry
ERR_BUFFER      =$81AC  ; circular buffer used by error handler
C_FULL_SCR_VAR	=$81D0	; last var pointed at from full screen menu in format
			; of OP1
CURRENT_MENU	=$820E	; current menu pointers (10 bytes)
RAISED_MENU	=$8218	; current raised up menu (10 bytes)
LST_VAR_MENU    =$8222  ; last variable menu shown (50 bytes, 10 for each
                        ; entry)
USER_MENU	=$8254	; string area used for TI-BASIC menus (40 bytes)
TEMP_STORAGE    =$827C  ; 128 bytes
SCROLL_START	=$8B2F	; first row of scrolling for SCROLL_UP
SCROLL_END      =$8B30  ; last row of scrolling for SCROLL_UP
CUSTOM_MENU     =$8BB1  ; custom menu data
HIGH_STACK      =$FA70  ; Stack space

